---
stages:
  - linting
  - build
  - test
  - cleanup

##
# Variables
##
variables:
  CHAINEDCI_TOOLS_GIT:
    https://gitlab.com/Orange-OpenSource/lfn/ci_cd/chained-ci-tools.git
  CHAINEDCI_TOOLS_DST: scripts
  CHAINED_CI_WEB_URL:
    "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/chained-ci-project-gating\
    /-/pipelines"
  # Gating Variables
  CHAINED_CI_PROJECT_ID: 25492165
  CHAINED_CI_LAUNCH_TOKEN: "$PUBLIC_CHAINED_CI_TOKEN"
  CHAINED_CI_PRIVATE_TOKEN: "$PUBLIC_CHAINED_CI_PRIVATE_TOKEN"
  DOCKER_TAG_NAME: OS_HARDENING_DOCKER_TAG
  # Path exclusion part
  PATH_EXCLUSION: './ci'
  # lockdown fails with markdown linter
  MARKDOWN_PATH_EXCLUSION: './roles/lockdown'
  PATH_EXCLUSION_CMD: '$PATH_EXCLUSION'
  MD_LINK_CHECK_PATH_EXCLUSION: "$PATH_EXCLUSION"
  SPELLING_PATH_EXCLUSION: "$PATH_EXCLUSION"
  JSON_PATH_EXCLUSION: "$PATH_EXCLUSION"
  YAML_PATH_EXCLUSION: "$PATH_EXCLUSION"
  # Ansible Lint part
  ANSIBLE_LINT_PATH: "roles/ playbooks/"
  # Hadolint part
  DOCKERFILE: "Dockerfile"
  GIT_SUBMODULE_STRATEGY: recursive

.gating_template: &gating_template
  stage: test
  image:
    "registry.gitlab.com/orange-opensource/lfn/ci_cd/\
     chained-ci-client-launcher:v1.0"
  script:
    - DOCKER_TAG="$(echo "$CI_COMMIT_REF_SLUG" | sed 's/^master$/latest/')"
    - export DOCKER_TAG
    - /usr/src/app/chained-ci-client-launcher/chained-ci-client.py
  after_script:
    - DOCKER_TAG="$(echo "$CI_COMMIT_REF_SLUG" | sed 's/^master$/latest/')"
    - export DOCKER_TAG
    - export SCENARIO=$(printf "%s_clean" "$SCENARIO")
    - export WAIT_FOR_END=False
    - /usr/src/app/chained-ci-client-launcher/chained-ci-client.py

test_centos_with_internet:
  variables:
    NAME: os-hardening-centos-internet
    SCENARIO: hardening_gating_centos
  <<: *gating_template

test_centos_without_internet:
  variables:
    NAME: os-hardening-centos-airgap
    SCENARIO: hardening_gating_centos_airgap
  <<: *gating_template

test_ubuntu_with_internet:
  variables:
    NAME: os-hardening-ubuntu-internet
    SCENARIO: hardening_gating_ubuntu
  <<: *gating_template

test_ubuntu_without_internet:
  variables:
    NAME: os-hardening-ubuntu-airgap
    SCENARIO: hardening_gating_ubuntu_airgap
  <<: *gating_template

include:
  - remote: "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/\
            gitlab-ci-templates/-/raw/master/ansible.gitlab-ci.yml"
  - remote: "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/gitlab-ci-templates\
            /-/raw/master/docker-chainedci-tools.gitlab-ci.yml"
  - remote: "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/\
            gitlab-ci-templates/-/raw/master/docker.linting.gitlab-ci.yml"
  - remote: "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/\
            gitlab-ci-templates/-/raw/master/json.gitlab-ci.yml"
  - remote: "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/\
            gitlab-ci-templates/-/raw/master/markdown.gitlab-ci.yml"
  - remote: "https://gitlab.com/Orange-OpenSource/lfn/ci_cd/\
            gitlab-ci-templates/-/raw/master/yaml.gitlab-ci.yml"
